// Code generated by "enumer -type=Column -json -text -yaml -sql"; DO NOT EDIT.

//
package columns

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _ColumnName = "Col1Col2Col3"

var _ColumnIndex = [...]uint8{0, 4, 8, 12}

func (i Column) String() string {
	if i < 0 || i >= Column(len(_ColumnIndex)-1) {
		return fmt.Sprintf("Column(%d)", i)
	}
	return _ColumnName[_ColumnIndex[i]:_ColumnIndex[i+1]]
}

var _ColumnValues = []Column{0, 1, 2}

var _ColumnNameToValueMap = map[string]Column{
	_ColumnName[0:4]:  0,
	_ColumnName[4:8]:  1,
	_ColumnName[8:12]: 2,
}

// ColumnString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func ColumnString(s string) (Column, error) {
	if val, ok := _ColumnNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to Column values", s)
}

// ColumnValues returns all values of the enum
func ColumnValues() []Column {
	return _ColumnValues
}

// IsAColumn returns "true" if the value is listed in the enum definition. "false" otherwise
func (i Column) IsAColumn() bool {
	for _, v := range _ColumnValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for Column
func (i Column) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for Column
func (i *Column) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("Column should be a string, got %s", data)
	}

	var err error
	*i, err = ColumnString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for Column
func (i Column) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for Column
func (i *Column) UnmarshalText(text []byte) error {
	var err error
	*i, err = ColumnString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for Column
func (i Column) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for Column
func (i *Column) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = ColumnString(s)
	return err
}

func (i Column) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *Column) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := ColumnString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
